/****************************************************************************
  $Id: TChannelDataListener.java,v 1.1 1998/12/01 19:26:22 toma Exp $
****************************************************************************/


package webwisdom.tango;


/**Interface for passing private application data using channel model.
 *@see TAgent#addTChannelDataListener*/
public interface TChannelDataListener
{


    /**This function is called everytime the data is sent
       by any member of the session and this participant
       is either an explicit addresee
       in <tt>channelSelectiveSend()</tt> function,
       or an implicit one in <tt>channelSend()</tt> function.
       The data arrives unchanged and in the same chunks as it was sent.
       *@param channel number of the channel into which the message was sent
       *@param data the data sent by another member of the same session
       *@see TAgent#send
       *@see TAgent#selectiveSend*/
    public void channelReceive(int channel,byte data[]);


}// TChannelDataListener ///////////////////////////////////////////////////

