// $Id: PasswdManager.java,v 1.4 1998/12/19 22:18:14 beca Exp $
/*
File: PasswdManager.java
Component: Server
Date		Author		Changes
Nov 30 98	Lukasz Beca	Created
*/

package webwisdom.tango.server;

 
import java.io.*;
import java.util.*;
import java.security.*;
import webwisdom.tango.test.Log;

public class PasswdManager {

//  private File passwdFile;
  
  private String passwdFilename;
  private MessageDigest md;  
  
  public PasswdManager(String filename) throws IOException {

//      passwdFile = new File(filename);

      passwdFilename = filename;
      
      try { 
       
	      md = MessageDigest.getInstance("SHA");      	       	    
	      
	    } catch(Exception e) {
	    
	      e.printStackTrace(Log.err);
	    
	    } 	    	           
  }
  
  public void close() {
   
    passwdFilename = null;
    md = null;
      	
	}  
  
  public String getPassword(String name) {
  
      String encPasswd;
            
      encPasswd = retrievePassword(name);
                  
      return encPasswd;
  
  }
  
  public String getStatus(String name) {
  
      String status;
            
      status = retrieveStatus(name);
                  
      return status;
     
  }
  
  public Hashtable getPasswordEntries() {
  
    String line, user, password = null;
    int separatorPos, endPos, tmp;
    FileReader passwdFileRead;      
    BufferedReader bufferedFile;
    Hashtable result = new Hashtable();
    File passwdFile;
  
    try { 
       
       passwdFile = new File(passwdFilename);
       passwdFileRead = new FileReader(passwdFile);      	       	    
	    		      
    } catch(FileNotFoundException e) {
	    
	      passwdFile = null;
		    passwdFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      passwdFile = null;
	      passwdFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  }
 
    bufferedFile = new BufferedReader(passwdFileRead);
 
    do {
      
      try {
      
        line = bufferedFile.readLine();
	
      } catch(Exception e) {

        Log.out.println("PasswdManager: " + e, 2);
        line = null;
        System.exit(1);
      }

      if (line != null) {

        if (!line.startsWith("#") && !line.startsWith(" ") && !line.startsWith("\n")){

		      separatorPos = line.indexOf(':');
		      tmp = line.lastIndexOf(':');
		      endPos = line.length();
		      
		      if (separatorPos > 0 && (tmp != separatorPos)) {
		      
			      user = line.substring(0, separatorPos);
				    password = line.substring(separatorPos + 1, endPos);				    				    
				    
				    if (password == null) {
				    
				      Log.out.println("PasswdManager: user has null password", 2);
				      password = new String("");
				    }
				    			    
				    result.put(user, password);
				    password = null;
		         
			    //  System.out.println("PasswdManager: user added with parameters " + user + " " + password);
          }          
        }
	    }

    } while(line != null);
    
    
    return result;

  }
    
   public Hashtable getStatusEntries() {
  
    String line, user, status;
    int separatorPos, endPos, tmp;
    FileReader passwdFileRead;      
    BufferedReader bufferedFile;
    Hashtable result = new Hashtable();
    File passwdFile;
    
    try { 
       
       passwdFile = new File(passwdFilename);
       passwdFileRead = new FileReader(passwdFile);      	       	    
	    		      
    } catch(FileNotFoundException e) {
	    
	      passwdFile = null;
		    passwdFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      passwdFile = null;
	      passwdFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  }
 
    bufferedFile = new BufferedReader(passwdFileRead);
 
    do {
      
      try {
      
        line = bufferedFile.readLine();
	
      } catch(Exception e) {

        System.out.println("PasswdManager: " + e);
        line = null;
        System.exit(1);
      }

      if (line != null) {

        if (!line.startsWith("#") && !line.startsWith(" ") && !line.startsWith("\n")){

		      tmp = line.indexOf(':');
		      separatorPos = line.lastIndexOf(':');
		      endPos = line.length();
		      
		      if (separatorPos > 0 && (tmp != separatorPos)) {
		      
			      user = line.substring(0, tmp);
				    status = line.substring(separatorPos + 1, endPos);
				    				    				    
				    if (status == null) {
				    
				      Log.out.println("PasswdManager: user has null status", 2);
				      status = new String("");
				    } 
				    			    
				    result.put(user, status);
				    
				    status = null;
		         
			    //  System.out.println("PasswdManager: user added with parameters " + user + " " + password);
          }          
        }
	    }

    } while(line != null);
    
    
    return result;

  }
  
    
    
  public boolean passwordOK(String name, String decPasswd) {
  
      String passwdFromFile;
      String encPasswd;            
      boolean result = false;	    
		        
      passwdFromFile = (String) retrievePassword(name);
                           
      if (decPasswd == null || passwdFromFile == null) {
      
	       return false;
	
	    } 
           
      if (decPasswd.length() == 0 && passwdFromFile.length() == 0) {
      
	      result = true;
	      
      } else {
      
        encPasswd = getEncPasswd(decPasswd);
	      result = encPasswd.equals(passwdFromFile);
      
      }                   
      
      return result;      
    
  }
  
  
  public void addEntry(String name, String decPasswd, String status) throws IOException {
  
     String newName;   
     String oldName;
     String userName;
     File oldFile;
     File oldPasswdFile;
     FileWriter passwdFileWrite;
	   BufferedWriter bWriteFile;
	   String line, newLine;
	   int namePos, separatorPos;
	   boolean existed = false;
	   BufferedReader bufferedFile;
	   String encPasswd;
	   FileReader passwdFileRead;
	   File passwdFile;
	   
	   
     if (name == null || decPasswd == null || status == null) {
     
       return;
     
     }
	 
	         
     encPasswd = getEncPasswd(decPasswd);          
  //   userTable.put(name, encPasswd);
        
	   newName = passwdFilename;
     oldName = newName + ".tmp";
//     oldFile = new File(oldName);
//     oldFile.delete();   
   
     oldPasswdFile = new File(oldName);
     
     passwdFile = new File(passwdFilename);     
     passwdFile.renameTo(oldPasswdFile);     
    
     
     try {
     
       passwdFileRead = new FileReader(oldPasswdFile);     
       bufferedFile = new BufferedReader(passwdFileRead);     
       line = bufferedFile.readLine();
       
     } catch(FileNotFoundException e) {
          
       line = null;
       bufferedFile = null;
     }
	   	   
     passwdFile = new File(newName);            
     passwdFileWrite = new FileWriter(passwdFile);
     bWriteFile = new BufferedWriter(passwdFileWrite);
      
     newLine = name + ":" + encPasswd + ":" + status;     
	 
	   while(line != null) {    		   		  


		      separatorPos = line.indexOf(':');
		      userName = line.substring(0, separatorPos);
			    
					if (userName.equals(name) && !line.startsWith("#")) {
					   
					   existed = true;      						 
						 bWriteFile.write(newLine, 0, newLine.length());
						 bWriteFile.newLine();
						 bWriteFile.flush();
						 
					} else {
					
//					  System.out.println("PasswdManager: " + line);
					  bWriteFile.write(line, 0, line.length());
					  bWriteFile.newLine();
					  bWriteFile.flush();
					  
					}
					
		      try {     
	         
		        line = bufferedFile.readLine();
       
		      } catch (Exception e) {
          
			       e.printStackTrace(Log.err);
       
		      }
                                                                            					
		}          
      
      
	  if (!existed) {
	    		                                                       
			bWriteFile.write(newLine, 0, newLine.length());
			bWriteFile.newLine();
			bWriteFile.flush();						   																	       																									       
		}
					
		bufferedFile.close();	
		bWriteFile.close();			
		oldPasswdFile.delete();
								  																																																 
																																																																																					 							       																								                                                                         
  }
  
  
   public void removeEntry(String name) throws IOException {
  
     String newName;   
     String oldName;
     String userName;
     int separatorPos;
     File oldFile;
     File oldPasswdFile;
     FileWriter passwdFileWrite;
	   BufferedWriter bWriteFile;
	   String line;
	   int namePos;
//	   boolean existed = false;
	   BufferedReader bufferedFile;
	   FileReader passwdFileRead;
	   File passwdFile;
	   
     if (name == null) {
     
       return;
     
     }
	 
	         
  //   encPasswd = getEncPasswd(decPasswd);          
  //   userTable.put(name, encPasswd);
        
	   newName = passwdFilename;
     oldName = newName + ".tmp";
//     oldFile = new File(oldName);
//     oldFile.delete();   
   
   
     oldPasswdFile = new File(oldName);
     passwdFile = new File(passwdFilename);
     passwdFile.renameTo(oldPasswdFile);     
//     oldPasswdFile = new File(oldName);
     
     try {
     
       passwdFileRead = new FileReader(oldPasswdFile);     
       bufferedFile = new BufferedReader(passwdFileRead);     
       line = bufferedFile.readLine();
       
     } catch(FileNotFoundException e) {
          
       line = null;
       bufferedFile = null;
     }
	   	   
     passwdFile = new File(newName);            
     passwdFileWrite = new FileWriter(passwdFile);
     bWriteFile = new BufferedWriter(passwdFileWrite);
      
    
	 
	   while(line != null) {    		   		  

			    namePos = line.indexOf(name);
			    
			    separatorPos = line.indexOf(':');
		      userName = line.substring(0, separatorPos);
			    
					if (userName.equals(name) || line.startsWith("#")) {
					   					 					
//					  System.out.println("PasswdManager: " + line);
					  bWriteFile.write(line, 0, line.length());
					  bWriteFile.newLine();
					  bWriteFile.flush();
					  
					}
					
		      try {     
	         
		        line = bufferedFile.readLine();
       
		      } catch (Exception e) {
          
			       e.printStackTrace(Log.err);
       
		      }
                                                                            					
		}    
		      
		bufferedFile.close();	
		bWriteFile.close();			
		oldPasswdFile.delete();											  																																																 
																																																																																					 							       																								                                                                         
  }

  
  private String getEncPasswd(String decPasswd) {           
         
     String encPasswd;
     StringBuffer tmpPasswd = new StringBuffer();
     byte[] table;
     int i;
         
     md.update(decPasswd.getBytes());                     
     table = md.digest();
     
     for (i = 0; i < table.length - 1; i ++) {
     
       tmpPasswd.append(String.valueOf(table[i]) + ".");     
     
     }
     
     tmpPasswd.append(String.valueOf(table[i]));
               
     encPasswd = tmpPasswd.toString();

     return encPasswd;
  
  }
  
  private String retrievePassword(String name)  {
  
    String line, user, password = null;
    int i, separatorPos, endPos;
    FileReader passwdFileRead;      
    BufferedReader bufferedFile;
    File passwdFile;
 
 
    try { 
       passwdFile = new File(passwdFilename);
       passwdFileRead = new FileReader(passwdFile);      	       	    
	    		      
    } catch(FileNotFoundException e) {
	    
		    passwdFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      passwdFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  }
 
    bufferedFile = new BufferedReader(passwdFileRead);
 
    do {
      
      try {
      
        line = bufferedFile.readLine();
	
      } catch(Exception e) {

        Log.out.println("Users: " + e, 2);
        line = null;
        System.exit(1);
      }

      if (line != null) {

        if (!line.startsWith("#") && !line.startsWith(" ") && !line.startsWith("\n")){

		      separatorPos = line.indexOf(':');
		      endPos = line.lastIndexOf(':');
		      
		      if (separatorPos > 0 && separatorPos != endPos) {
		      
			      user = line.substring(0, separatorPos);
			      
			      if (user.equals(name)) {
			      
				      password = line.substring(separatorPos + 1, endPos);
				      
				    }				    
          }          
        }
	    }

    } while(line != null && password == null);
    
    
    return password;
    
  }
  
  private String retrieveStatus(String name)  {
  
    String line, user, status = null;
    int i, separatorPos, endPos, tmp;
    FileReader passwdFileRead;      
    BufferedReader bufferedFile;
    File passwdFile;
 
    try { 
       passwdFile = new File(passwdFilename);
       passwdFileRead = new FileReader(passwdFile);      	       	    
	    		      
    } catch(FileNotFoundException e) {
	    
		    passwdFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      passwdFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  }
 
    bufferedFile = new BufferedReader(passwdFileRead);
 
    do {
      
      try {
      
        line = bufferedFile.readLine();
	
      } catch(Exception e) {

        Log.out.println("Users: " + e, 2);
        line = null;
        System.exit(1);
      }

      if (line != null) {

        if (!line.startsWith("#") && !line.startsWith(" ") && !line.startsWith("\n")){

		      tmp = line.indexOf(':');
		      separatorPos = line.lastIndexOf(':');
		      endPos = line.length();
		      
		      if (separatorPos > 0 && (tmp != separatorPos)) {
		      
			      user = line.substring(0, tmp);
			      
			      if (user.equals(name)) {
			      
				      status = line.substring(separatorPos + 1, endPos);
				      
				    }				    
				  }
				}  
	    }

    } while(line != null && status == null);
    
    
    return status;
    
  }
  
}
